/*********************************************
 * BIOE-GUI - a frontend for the BIOE system, WIN32/UNIX
 * Copyright (C) 2010  Weichinger Klaus, snaky.1@gmx.at
 * 
 * License: CC-GNU GPL
 * http://creativecommons.org/licenses/GPL/2.0/ 
 *********************************************
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA.
 *********************************************/

#ifndef _BIOEDeviceWidget_H_
#define _BIOEDeviceWidget_H_

#include <FL/Fl.H>
#include <FL/fl_ask.H>
#include <FL/Fl_Group.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Int_Input.H>
#include <FL/Fl_Choice.H>

class BIOEDeviceWidget: public Fl_Group{
  public:
    int adr;
    BIOEDeviceWidget(int x, int y, int adr);
//    ~BIOEDeviceWidget();
    void DeviceTest(void);
    void processDevice();
    int handle(int e);
    void setInterface(int port, int cs);
  private:
    int port, cs;
    Fl_Group  *titlebar_grp;
    Fl_Button *x_btn;
    
    Fl_Choice *level_btn;
    Fl_Int_Input *DTN_txt;

    Fl_Button *setdtn_btn;
    Fl_Button *readsettings_btn;
    Fl_Button *writesettings_btn;

    Fl_Int_Input *ep2in_txt;
    Fl_Int_Input *ep2out_txt;

    Fl_Int_Input *ep3in_txt;
    Fl_Int_Input *ep3out_txt;
    
    Fl_Int_Input *ep4in_txt;
    Fl_Int_Input *ep4out_txt;

    Fl_Int_Input *ep5in_txt;
    Fl_Int_Input *ep5out_txt;

    Fl_Int_Input *ep6in_txt;
    Fl_Int_Input *ep6out_txt;

    Fl_Int_Input *ep7in_txt;
    Fl_Int_Input *ep7out_txt;

    Fl_Int_Input *ep8in_txt;
    Fl_Int_Input *ep8out_txt;

    Fl_Int_Input *ep9in_txt;
    Fl_Int_Input *ep9out_txt;

    Fl_Int_Input *ep10in_txt;
    Fl_Int_Input *ep10out_txt;

    Fl_Int_Input *ep11in_txt;
    Fl_Int_Input *ep11out_txt;

    Fl_Int_Input *ep12in_txt;
    Fl_Int_Input *ep12out_txt;

    Fl_Int_Input *ep13in_txt;
    Fl_Int_Input *ep13out_txt;

    Fl_Int_Input *ep14in_txt;
    Fl_Int_Input *ep14out_txt;

    Fl_Int_Input *s0_txt;
    Fl_Int_Input *s1_txt;
    Fl_Int_Input *s2_txt;
    Fl_Int_Input *s3_txt;
    Fl_Int_Input *s4_txt;
    Fl_Int_Input *s5_txt;
    Fl_Int_Input *s6_txt;
    Fl_Int_Input *s7_txt;

    static void x_btn_scb(Fl_Widget* w, void* data) {
	  ((BIOEDeviceWidget*)data)->x_btn_cb();
    }
    void x_btn_cb();

    static void level_btn_scb(Fl_Widget* w, void* data) {
	  ((BIOEDeviceWidget*)data)->level_btn_cb();
    }
    void level_btn_cb();

    static void setdtn_btn_scb(Fl_Widget* w, void* data) {
	  ((BIOEDeviceWidget*)data)->setdtn_btn_cb();
    }
    void setdtn_btn_cb();

    static void readsettings_btn_scb(Fl_Widget* w, void* data) {
	  ((BIOEDeviceWidget*)data)->readsettings_btn_cb();
    }
    void readsettings_btn_cb();

    static void writesettings_btn_scb(Fl_Widget* w, void* data) {
	  ((BIOEDeviceWidget*)data)->writesettings_btn_cb();
    }
    void writesettings_btn_cb();
};
#endif
