/*********************************************
 * BIOE-GUI - a frontend for the BIOE system, WIN32/UNIX
 * Copyright (C) 2010  Weichinger Klaus, snaky.1@gmx.at
 * 
 * License: CC-GNU GPL
 * http://creativecommons.org/licenses/GPL/2.0/ 
 *********************************************
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA.
 *********************************************/

#include "BIOEMain.h"
#define processingintervall 0.1

BIOEMain_Frm::BIOEMain_Frm(): Fl_Double_Window (600,600,"BIOEGUI 0.2 by Weichinger Klaus") {                              
  int pos;
  this->image(img_configure_xpm);                              
  this->size_range(450, 400);
  this->position((Fl::w()-this->w())/2, (Fl::h()-this->h())/2);

  toolbar_grp=new Fl_Group(0,0,w(),65);    
    toolbar_grp->box(FL_THIN_UP_BOX);

    grabber1_grp=new Fl_Group(3,4,3,57);grabber1_grp->end();
    grabber1_grp->box(FL_THIN_UP_BOX);
    grabber2_grp=new Fl_Group(7,4,3,57);grabber2_grp->end();
    grabber2_grp->box(FL_THIN_UP_BOX);
    pos=15;

    scandevices_btn=new Fl_Button(pos,4,50,57,"Search\nDevices"); pos+=50;
    scandevices_btn->image(img_search_xpm);
    scandevices_btn->labelsize(11);
    scandevices_btn->callback(scandevices_btn_scb,this);

    testdevice_btn=new Fl_Button(pos,4,50,57,"Test\nDevice"); pos+=50;
    testdevice_btn->image(img_ok_xpm);
    testdevice_btn->labelsize(11);
    testdevice_btn->callback(testdevice_btn_scb,this);

    pos+=5;

//    processalldevices_btn=new Fl_Button(pos,4,100,57,"Process all\nDevices"); pos+=100;
//    processalldevices_btn->image(img_stepright_xpm);
//    processalldevices_btn->labelsize(11);
//    processalldevices_btn->callback(processalldevices_btn_scb,this);
//    processalldevices_btn->box(FL_FLAT_BOX);
//    processalldevices_btn->down_box(FL_BORDER_BOX);    
    
    processcurrentdevice_btn=new Fl_Button(pos,4,100,57,"Process current\nDevice"); pos+=100;
    processcurrentdevice_btn->image(img_steprightsingle_xpm);
    processcurrentdevice_btn->labelsize(11);
    processcurrentdevice_btn->callback(processcurrentdevice_btn_scb,this);
//    processcurrentdevice_btn->box(FL_FLAT_BOX);
//    processcurrentdevice_btn->down_box(FL_BORDER_BOX);    


    spacer_grp=new Fl_Group(pos,4,600-4-50-50-pos,57); spacer_grp->end();
    toolbar_grp->resizable(spacer_grp);

    pos=600-4-50-50;
    help_btn=new Fl_Button(pos,4,50,57,"Help");pos+=50;
    help_btn->image(img_help_xpm);
    help_btn->labelsize(11);
    help_btn->callback(help_btn_scb,this);

    closeapp_btn=new Fl_Button(pos,4,50,57,"Close");pos+=50;
    closeapp_btn->image(img_exit_xpm);
    closeapp_btn->labelsize(11);
    closeapp_btn->callback(closeapp_btn_scb,this);
  toolbar_grp->end();
  
  main_grp = new Fl_Group(0,65,w(),h()-(65+25));
    left_grp=new Fl_Group(0,main_grp->y()+2,150,main_grp->h()-4);
      interface_grp=new Fl_Group(0,65+2,150,62);
        interface_grp->box(FL_THIN_DOWN_BOX);
        lptport_txt=new Fl_Input(70, 70, 70, 25, "Port:");
        char val[30];
        sprintf(val,"%d",888);
        #ifdef unix
          sprintf(val,"%d",BIOE_ReadConfigFile_Int(defaultsettingsfile,"bioe_port",atoi(val)));
        #endif
        sprintf(val,"%d",BIOE_ReadConfigFile_Int("bioesettings.conf","bioe_port",atoi(val)));
        lptport_txt->value(val);
        cs_txt=new Fl_Input(70, 100, 70, 25, "CS:");
        sprintf(val,"%d",1);
        #ifdef unix
          sprintf(val,"%d",BIOE_ReadConfigFile_Int(defaultsettingsfile,"bioe_cs",atoi(val)));
        #endif
        sprintf(val,"%d",BIOE_ReadConfigFile_Int("bioesettings.conf","bioe_cs",atoi(val)));
        cs_txt->value(val);
      interface_grp->end();
      devices_grp=new Fl_Scroll(0,interface_grp->y()+interface_grp->h()+2,150,left_grp->h()-(2+interface_grp->h()));
        devices_grp->box(FL_THIN_DOWN_BOX);
        devices_grp->type(Fl_Scroll::VERTICAL_ALWAYS);
        device0_btn=new Fl_Button(devices_grp->x()+6,
        			devices_grp->y()+4,120,25,"Device 0");
        device0_btn->callback(device0_btn_scb,this);

        device1_btn=new Fl_Button(device0_btn->x(),
        			device0_btn->y()+27,120,25,"Device 1");
        device1_btn->callback(device1_btn_scb,this);

        device2_btn=new Fl_Button(device1_btn->x(),
        			device1_btn->y()+27,120,25,"Device 2");
        device2_btn->callback(device2_btn_scb,this);

        device3_btn=new Fl_Button(device2_btn->x(),
        			device2_btn->y()+27,120,25,"Device 3");
        device3_btn->callback(device3_btn_scb,this);

        device4_btn=new Fl_Button(device3_btn->x(),
        			device3_btn->y()+27,120,25,"Device 4");
        device4_btn->callback(device4_btn_scb,this);

        device5_btn=new Fl_Button(device4_btn->x(),
        			device4_btn->y()+27,120,25,"Device 5");
        device5_btn->callback(device5_btn_scb,this);

        device6_btn=new Fl_Button(device5_btn->x(),
        			device5_btn->y()+27,120,25,"Device 6");
        device6_btn->callback(device6_btn_scb,this);

        device7_btn=new Fl_Button(device6_btn->x(),
        			device6_btn->y()+27,120,25,"Device 7");
        device7_btn->callback(device7_btn_scb,this);

        device8_btn=new Fl_Button(device7_btn->x(),
        			device7_btn->y()+27,120,25,"Device 8");
        device8_btn->callback(device8_btn_scb,this);

        device9_btn=new Fl_Button(device8_btn->x(),
        			device8_btn->y()+27,120,25,"Device 9");
        device9_btn->callback(device9_btn_scb,this);

        device10_btn=new Fl_Button(device9_btn->x(),
        			device9_btn->y()+27,120,25,"Device 10");
        device10_btn->callback(device10_btn_scb,this);

        device11_btn=new Fl_Button(device10_btn->x(),
        			device10_btn->y()+27,120,25,"Device 11");
        device11_btn->callback(device11_btn_scb,this);

        device12_btn=new Fl_Button(device11_btn->x(),
        			device11_btn->y()+27,120,25,"Device 12");
        device12_btn->callback(device12_btn_scb,this);

        device13_btn=new Fl_Button(device12_btn->x(),
        			device12_btn->y()+27,120,25,"Device 13");
        device13_btn->callback(device13_btn_scb,this);

        device14_btn=new Fl_Button(device13_btn->x(),
        			device13_btn->y()+27,120,25,"Device 14");
        device14_btn->callback(device14_btn_scb,this);

        device15_btn=new Fl_Button(device14_btn->x(),
        			device14_btn->y()+27,120,25,"Device 15");
        device15_btn->callback(device15_btn_scb,this);

        device0_btn->deactivate();
        device1_btn->deactivate();
        device2_btn->deactivate();
        device3_btn->deactivate();
        device4_btn->deactivate();
        device5_btn->deactivate();
        device6_btn->deactivate();
        device7_btn->deactivate();
        device8_btn->deactivate();
        device9_btn->deactivate();
        device10_btn->deactivate();
        device11_btn->deactivate();
        device12_btn->deactivate();
        device13_btn->deactivate();
        device14_btn->deactivate();
        device15_btn->deactivate();
      devices_grp->end();
      left_grp->resizable(devices_grp);
    left_grp->end();
    workspace_grp=new Fl_Scroll(150+4,main_grp->y()+2,main_grp->w()-150-4,main_grp->h()-4);
      main_grp->resizable(workspace_grp);    
      workspace_grp->box(FL_THIN_DOWN_BOX);
      workspace_grp->type(Fl_Scroll::BOTH_ALWAYS);
//      workspace_grp->color(FL_WHITE);
    workspace_grp->end();
  main_grp->end();
  this->resizable(main_grp);

  status_grp = new Fl_Group(0,h()-25,w(),25,"First search for Devices!");
    status_grp->align(FL_ALIGN_LEFT+FL_ALIGN_INSIDE);
    status_grp->box(FL_THIN_DOWN_BOX);
  status_grp->end();

  Fl::add_timeout(processingintervall, processing_scb,this);
  
  this->end();
}

BIOEMain_Frm::~BIOEMain_Frm() {

}

void BIOEMain_Frm::processing_cb() {
  int i=0;

//  if (processalldevices_btn->value()==1) { // von allen Gerten die EP behandeln
//  }
  if (processcurrentdevice_btn->value()==1) { // vom aktuellen Gert die EP behandeln
    i=workspace_grp->children();
    if (i>2) {
      i=i-3;
      if (workspace_grp->child(i)==device0) device0->processDevice();
      if (workspace_grp->child(i)==device1) device1->processDevice();
      if (workspace_grp->child(i)==device2) device2->processDevice();
      if (workspace_grp->child(i)==device3) device3->processDevice();
      if (workspace_grp->child(i)==device4) device4->processDevice();
      if (workspace_grp->child(i)==device5) device5->processDevice();
      if (workspace_grp->child(i)==device6) device6->processDevice();
      if (workspace_grp->child(i)==device7) device7->processDevice();
      if (workspace_grp->child(i)==device8) device8->processDevice();
      if (workspace_grp->child(i)==device9) device9->processDevice();
      if (workspace_grp->child(i)==device10) device10->processDevice();
      if (workspace_grp->child(i)==device11) device11->processDevice();
      if (workspace_grp->child(i)==device12) device12->processDevice();
      if (workspace_grp->child(i)==device13) device13->processDevice();
      if (workspace_grp->child(i)==device14) device14->processDevice();
      if (workspace_grp->child(i)==device15) device15->processDevice();
    }  
  }
  Fl::repeat_timeout(processingintervall, processing_scb,this);  
}


void BIOEMain_Frm::closeapp_btn_cb(void) {
  this->hide();
}

void BIOEMain_Frm::help_btn_cb(void) {
  fl_message("BIOE is a low-cost io-system using a parallel bus \nto control plants using a standard pc running on Linux or Windows.\n\nLicense: CC-GPLv2, see license.txt\nAuthor: Weichinger Klaus - snaky.1@@gmx.at - 2010");
}

void BIOEMain_Frm::scandevices_btn_cb(void) {
  unsigned short basePort,channel;
//  sscanf(lptport_txt->value(),"%x",basePort);
  basePort=atoi(lptport_txt->value());
  channel=atoi(cs_txt->value());
//  device0_btn->activate();
  device0_btn->deactivate();
  device1_btn->deactivate();
  device2_btn->deactivate();
  device3_btn->deactivate();
  device4_btn->deactivate();
  device5_btn->deactivate();
  device6_btn->deactivate();
  device7_btn->deactivate();
  device8_btn->deactivate();
  device9_btn->deactivate();
  device10_btn->deactivate();
  device11_btn->deactivate();
  device12_btn->deactivate();
  device13_btn->deactivate();
  device14_btn->deactivate();
  device15_btn->deactivate();
  BIOE_Init(basePort);
  if (BIOE_DeviceExists(basePort,channel,0)==0) device0_btn->activate();
  if (BIOE_DeviceExists(basePort,channel,1)==0) device1_btn->activate();
  if (BIOE_DeviceExists(basePort,channel,2)==0) device2_btn->activate();
  if (BIOE_DeviceExists(basePort,channel,3)==0) device3_btn->activate();
  if (BIOE_DeviceExists(basePort,channel,4)==0) device4_btn->activate();
  if (BIOE_DeviceExists(basePort,channel,5)==0) device5_btn->activate();
  if (BIOE_DeviceExists(basePort,channel,6)==0) device6_btn->activate();
  if (BIOE_DeviceExists(basePort,channel,7)==0) device7_btn->activate();
  if (BIOE_DeviceExists(basePort,channel,8)==0) device8_btn->activate();
  if (BIOE_DeviceExists(basePort,channel,9)==0) device9_btn->activate();
  if (BIOE_DeviceExists(basePort,channel,10)==0) device10_btn->activate();
  if (BIOE_DeviceExists(basePort,channel,11)==0) device11_btn->activate();
  if (BIOE_DeviceExists(basePort,channel,12)==0) device12_btn->activate();
  if (BIOE_DeviceExists(basePort,channel,13)==0) device13_btn->activate();
  if (BIOE_DeviceExists(basePort,channel,14)==0) device14_btn->activate();
  if (BIOE_DeviceExists(basePort,channel,15)==0) device15_btn->activate();
  BIOE_Close(basePort);
  status_grp->label("Devicesearch done! Enabled Devicebutton indicates an existing Device.");
}

void BIOEMain_Frm::testdevice_btn_cb(void) {
  int i=0;
  i=workspace_grp->children();
  if (i>2) {
    i=i-3;
    if (workspace_grp->child(i)==device0) device0->DeviceTest();
    if (workspace_grp->child(i)==device1) device1->DeviceTest();
    if (workspace_grp->child(i)==device2) device2->DeviceTest();
    if (workspace_grp->child(i)==device3) device3->DeviceTest();
    if (workspace_grp->child(i)==device4) device4->DeviceTest();
    if (workspace_grp->child(i)==device5) device5->DeviceTest();
    if (workspace_grp->child(i)==device6) device6->DeviceTest();
    if (workspace_grp->child(i)==device7) device7->DeviceTest();
    if (workspace_grp->child(i)==device8) device8->DeviceTest();
    if (workspace_grp->child(i)==device9) device9->DeviceTest();
    if (workspace_grp->child(i)==device10) device10->DeviceTest();
    if (workspace_grp->child(i)==device11) device11->DeviceTest();
    if (workspace_grp->child(i)==device12) device12->DeviceTest();
    if (workspace_grp->child(i)==device13) device13->DeviceTest();
    if (workspace_grp->child(i)==device14) device14->DeviceTest();
    if (workspace_grp->child(i)==device15) device15->DeviceTest();
  }
}

/*
void BIOEMain_Frm::processalldevices_btn_cb() {
  if (processalldevices_btn->value()==0) {
    processcurrentdevice_btn->clear();
    processalldevices_btn->set();
  } else {
    processalldevices_btn->clear();
  }
}
*/

void BIOEMain_Frm::processcurrentdevice_btn_cb() {
  if (processcurrentdevice_btn->value()==0) {
//    processalldevices_btn->clear();
    processcurrentdevice_btn->set();
  } else {
    processcurrentdevice_btn->clear();
  }
}

void BIOEMain_Frm::device0_btn_cb(void) {
  unsigned short basePort,channel;
  if (workspace_grp->find(device0)==workspace_grp->children()) {
    device0=new BIOEDeviceWidget(workspace_grp->x()+2,workspace_grp->y()+2+20*0,0);
    workspace_grp->add(device0);
  } else {
    workspace_grp->remove(device0);
    workspace_grp->add(device0);
  }
  basePort=atoi(lptport_txt->value());
  channel=atoi(cs_txt->value());
  device0->setInterface(basePort,channel);
  workspace_grp->redraw();
}

void BIOEMain_Frm::device1_btn_cb(void) {
  unsigned short basePort,channel;
  if (workspace_grp->find(device1)==workspace_grp->children()) {
    device1=new BIOEDeviceWidget(workspace_grp->x()+2,workspace_grp->y()+2+20*1,1);
    workspace_grp->add(device1);
  } else {
    workspace_grp->remove(device1);
    workspace_grp->add(device1);
  }
  basePort=atoi(lptport_txt->value());
  channel=atoi(cs_txt->value());
  device1->setInterface(basePort,channel);
  workspace_grp->redraw();
}

void BIOEMain_Frm::device2_btn_cb(void) {
  unsigned short basePort,channel;
  if (workspace_grp->find(device2)==workspace_grp->children()) {
    device2=new BIOEDeviceWidget(workspace_grp->x()+2,workspace_grp->y()+2+20*2,2);
    workspace_grp->add(device2);
  } else {
    workspace_grp->remove(device2);
    workspace_grp->add(device2);
  }
  basePort=atoi(lptport_txt->value());
  channel=atoi(cs_txt->value());
  device2->setInterface(basePort,channel);
  workspace_grp->redraw();
}

void BIOEMain_Frm::device3_btn_cb(void) {
  unsigned short basePort,channel;
  if (workspace_grp->find(device3)==workspace_grp->children()) {
    device3=new BIOEDeviceWidget(workspace_grp->x()+2,workspace_grp->y()+2+20*3,3);
    workspace_grp->add(device3);
  } else {
    workspace_grp->remove(device3);
    workspace_grp->add(device3);
  }
  basePort=atoi(lptport_txt->value());
  channel=atoi(cs_txt->value());
  device3->setInterface(basePort,channel);
  workspace_grp->redraw();
}

void BIOEMain_Frm::device4_btn_cb(void) {
  unsigned short basePort,channel;
  if (workspace_grp->find(device4)==workspace_grp->children()) {
    device4=new BIOEDeviceWidget(workspace_grp->x()+2,workspace_grp->y()+2+20*4,4);
    workspace_grp->add(device4);
  } else {
    workspace_grp->remove(device4);
    workspace_grp->add(device4);
  }
  basePort=atoi(lptport_txt->value());
  channel=atoi(cs_txt->value());
  device4->setInterface(basePort,channel);
  workspace_grp->redraw();
}

void BIOEMain_Frm::device5_btn_cb(void) {
  unsigned short basePort,channel;
  if (workspace_grp->find(device5)==workspace_grp->children()) {
    device5=new BIOEDeviceWidget(workspace_grp->x()+2,workspace_grp->y()+2+20*5,5);
    workspace_grp->add(device5);
  } else {
    workspace_grp->remove(device5);
    workspace_grp->add(device5);
  }
  basePort=atoi(lptport_txt->value());
  channel=atoi(cs_txt->value());
  device5->setInterface(basePort,channel);
  workspace_grp->redraw();
}

void BIOEMain_Frm::device6_btn_cb(void) {
  unsigned short basePort,channel;
  if (workspace_grp->find(device6)==workspace_grp->children()) {
    device6=new BIOEDeviceWidget(workspace_grp->x()+2,workspace_grp->y()+2+20*6,6);
    workspace_grp->add(device6);
  } else {
    workspace_grp->remove(device6);
    workspace_grp->add(device6);
  }
  basePort=atoi(lptport_txt->value());
  channel=atoi(cs_txt->value());
  device6->setInterface(basePort,channel);
  workspace_grp->redraw();
}

void BIOEMain_Frm::device7_btn_cb(void) {
  unsigned short basePort,channel;
  if (workspace_grp->find(device7)==workspace_grp->children()) {
    device7=new BIOEDeviceWidget(workspace_grp->x()+2,workspace_grp->y()+2+20*7,7);
    workspace_grp->add(device7);
  } else {
    workspace_grp->remove(device7);
    workspace_grp->add(device7);
  }
  basePort=atoi(lptport_txt->value());
  channel=atoi(cs_txt->value());
  device7->setInterface(basePort,channel);
  workspace_grp->redraw();
}

void BIOEMain_Frm::device8_btn_cb(void) {
  unsigned short basePort,channel;
  if (workspace_grp->find(device8)==workspace_grp->children()) {
    device8=new BIOEDeviceWidget(workspace_grp->x()+2,workspace_grp->y()+2+20*8,8);
    workspace_grp->add(device8);
  } else {
    workspace_grp->remove(device8);
    workspace_grp->add(device8);
  }
  basePort=atoi(lptport_txt->value());
  channel=atoi(cs_txt->value());
  device8->setInterface(basePort,channel);
  workspace_grp->redraw();
}

void BIOEMain_Frm::device9_btn_cb(void) {
  unsigned short basePort,channel;
  if (workspace_grp->find(device9)==workspace_grp->children()) {
    device9=new BIOEDeviceWidget(workspace_grp->x()+2,workspace_grp->y()+2+20*9,9);
    workspace_grp->add(device9);
  } else {
    workspace_grp->remove(device9);
    workspace_grp->add(device9);
  }
  basePort=atoi(lptport_txt->value());
  channel=atoi(cs_txt->value());
  device9->setInterface(basePort,channel);
  workspace_grp->redraw();
}

void BIOEMain_Frm::device10_btn_cb(void) {
  unsigned short basePort,channel;
  if (workspace_grp->find(device10)==workspace_grp->children()) {
    device10=new BIOEDeviceWidget(workspace_grp->x()+2,workspace_grp->y()+2+20*10,10);
    workspace_grp->add(device10);
  } else {
    workspace_grp->remove(device10);
    workspace_grp->add(device10);
  }
  basePort=atoi(lptport_txt->value());
  channel=atoi(cs_txt->value());
  device10->setInterface(basePort,channel);
  workspace_grp->redraw();
}

void BIOEMain_Frm::device11_btn_cb(void) {
  unsigned short basePort,channel;
  if (workspace_grp->find(device11)==workspace_grp->children()) {
    device11=new BIOEDeviceWidget(workspace_grp->x()+2,workspace_grp->y()+2+20*11,11);
    workspace_grp->add(device11);
  } else {
    workspace_grp->remove(device11);
    workspace_grp->add(device11);
  }
  basePort=atoi(lptport_txt->value());
  channel=atoi(cs_txt->value());
  device11->setInterface(basePort,channel);
  workspace_grp->redraw();
}

void BIOEMain_Frm::device12_btn_cb(void) {
  unsigned short basePort,channel;
  if (workspace_grp->find(device12)==workspace_grp->children()) {
    device12=new BIOEDeviceWidget(workspace_grp->x()+2,workspace_grp->y()+2+20*12,12);
    workspace_grp->add(device12);
  } else {
    workspace_grp->remove(device12);
    workspace_grp->add(device12);
  }
  basePort=atoi(lptport_txt->value());
  channel=atoi(cs_txt->value());
  device12->setInterface(basePort,channel);
  workspace_grp->redraw();
}

void BIOEMain_Frm::device13_btn_cb(void) {
  unsigned short basePort,channel;
  if (workspace_grp->find(device13)==workspace_grp->children()) {
    device13=new BIOEDeviceWidget(workspace_grp->x()+2,workspace_grp->y()+2+20*13,13);
    workspace_grp->add(device13);
  } else {
    workspace_grp->remove(device13);
    workspace_grp->add(device13);
  }
  basePort=atoi(lptport_txt->value());
  channel=atoi(cs_txt->value());
  device13->setInterface(basePort,channel);
  workspace_grp->redraw();
}

void BIOEMain_Frm::device14_btn_cb(void) {
  unsigned short basePort,channel;
  if (workspace_grp->find(device14)==workspace_grp->children()) {
    device14=new BIOEDeviceWidget(workspace_grp->x()+2,workspace_grp->y()+2+20*14,14);
    workspace_grp->add(device14);
  } else {
    workspace_grp->remove(device14);
    workspace_grp->add(device14);
  }
  basePort=atoi(lptport_txt->value());
  channel=atoi(cs_txt->value());
  device14->setInterface(basePort,channel);
  workspace_grp->redraw();
}

void BIOEMain_Frm::device15_btn_cb(void) {
  unsigned short basePort,channel;
  if (workspace_grp->find(device15)==workspace_grp->children()) {
    device15=new BIOEDeviceWidget(workspace_grp->x()+2,workspace_grp->y()+2+20*15,15);
    workspace_grp->add(device15);
  } else {
    workspace_grp->remove(device15);
    workspace_grp->add(device15);
  }
  basePort=atoi(lptport_txt->value());
  channel=atoi(cs_txt->value());
  device15->setInterface(basePort,channel);
  workspace_grp->redraw();
}

