/*********************************************
 * BIOE-Library - communication library for the BIOE system, WIN32/UNIX
 * Copyright (C) 2010  Weichinger Klaus, snaky.1@gmx.at
 * 
 * License: CC-GNU GPL
 * http://creativecommons.org/licenses/GPL/2.0/ 
 *********************************************
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA.
 *********************************************/

#ifndef _bioe_h_
#define _bioe_h_

#ifdef unix
  #define defaultsettingsfile "/usr/local/bioe/bioesettings.conf"
#endif
#ifdef _WIN32
  #define defaultsettingsfile "not required yet"
#endif

int BIOE_Transaction(int basePort,int channel,int Device,int Endpoint,int Value, int speedfactor, int pausefactor);
int BIOE_ConfigTransaction(int basePort,
                            int channel,
                            int Device,
                            int Action,
                            int Data,
                            int speedfactor,
                            int pausefactor);
void BIOE_Init(int basePort);
void BIOE_Close(int basePort);
int BIOE_DeviceExists(int basePort, int channel, int Device);
int BIOE_ReadConfigFile_Int(char *filename, char* paramname, int defaultvalue);
void BIOE_WriteConfigFile(char *filename, char *ID, int port, int cs, int speedfactor, int pausefactor);
#endif
